Index: less/LICENSE
diff -u less/LICENSE:1.1.1.2 less/LICENSE:1.2
--- less/LICENSE:1.1.1.2	Sun Oct 29 02:03:35 2000
+++ less/LICENSE	Tue Oct 31 04:30:38 2000
@@ -4,6 +4,9 @@
 Less
 Copyright (C) 1984-2000  Mark Nudelman
 
+Japanized part of Less
+Copyright (c) 1994-2000  Kazushi (Jam) Marukawa
+
 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions
 are met:
Index: less/Makefile.aut
diff -u less/Makefile.aut:1.1.1.7 less/Makefile.aut:1.10
--- less/Makefile.aut:1.1.1.7	Sun Oct 29 02:19:12 2000
+++ less/Makefile.aut	Sun Oct 29 02:34:40 2000
@@ -14,14 +14,14 @@
 	help.c ifile.c input.c jump.c line.c linenum.c \
 	lsystem.c mark.c optfunc.c option.c opttbl.c os.c \
 	output.c position.c prompt.c search.c signal.c \
-	tags.c ttyin.c version.c  
+	tags.c ttyin.c version.c multi.c unify.c  
 DISTFILES_W = \
 	defines.ds  Makefile.dsb Makefile.dsg Makefile.dsu \
 	defines.o2  Makefile.o2e \
 	defines.o9  Makefile.o9c Makefile.o9u \
 	defines.wn  Makefile.wnm Makefile.wnb
 DISTFILES = \
-	${SRC} regexp.c regexp.h \
+	${SRC} regexp.c regexp.h multi.h \
 	COPYING INSTALL LICENSE Makefile.in Makefile.aut NEWS README \
 	configure configure.in acconfig.h lesskey.c lessecho.c \
 	cmd.h funcs.h lglob.h less.h lesskey.h option.h pckeys.h position.h \
Index: less/Makefile.dsb
diff -u less/Makefile.dsb:1.1.1.1 less/Makefile.dsb:1.4
--- less/Makefile.dsb:1.1.1.1	Sat Nov 30 14:41:23 1996
+++ less/Makefile.dsb	Thu Mar 12 17:29:03 1998
@@ -23,7 +23,7 @@
 	input.obj jump.obj line.obj linenum.obj lsystem.obj \
 	mark.obj optfunc.obj option.obj opttbl.obj os.obj output.obj \
 	position.obj prompt.obj search.obj signal.obj tags.obj \
-	ttyin.obj version.obj
+	ttyin.obj version.obj multi.obj unify.obj
 
 all: less$(EXT) lesskey$(EXT)
 
@@ -41,7 +41,7 @@
 	-del defines.h
 	-copy defines.ds defines.h
 
-$(OBJ): less.h defines.h
+$(OBJ): less.h multi.h defines.h
 
 clean:
 	-del *.obj 
Index: less/Makefile.dsg
diff -u less/Makefile.dsg:1.1.1.3 less/Makefile.dsg:1.6
--- less/Makefile.dsg:1.1.1.3	Sun Oct 29 02:03:39 2000
+++ less/Makefile.dsg	Sun Oct 29 02:17:16 2000
@@ -28,7 +28,7 @@
 	help.${O} ifile.${O} input.${O} jump.${O} line.${O} linenum.${O} \
 	lsystem.${O} mark.${O} optfunc.${O} option.${O} opttbl.${O} os.${O} \
 	output.${O} position.${O} prompt.${O} search.${O} signal.${O} \
-	tags.${O} ttyin.${O} version.${O}
+	tags.${O} ttyin.${O} version.${O} multi.${O} unify.${O}
 
 all: less lesskey lessecho
 
@@ -44,7 +44,7 @@
 defines.h: defines.ds
 	command.com /c copy $< $@
 
-${OBJ}: less.h defines.h funcs.h
+${OBJ}: less.h multi.h defines.h funcs.h
 
 info:
 install-info:
Index: less/Makefile.dsm
diff -u /dev/null less/Makefile.dsm:1.4
--- /dev/null	Wed Dec  6 22:29:41 2000
+++ less/Makefile.dsm	Thu Mar 12 17:29:03 1998
@@ -0,0 +1,58 @@
+# Makefile for less.
+# MS-DOS version
+
+#### Start of system configuration section. ####
+
+CC = cl
+# Change the following directories to match your installation.
+LIBDIR = c:\msvc\lib
+INCDIR = c:\msvc\include
+
+# CFLAGS are compile-time options and LDFLAGS are link-time options. They are
+# customized for MSVC 1.0 (MSC 8.0). If you have a different version of the
+# compiler, you may need to change some of the options to their equivalents.
+# -Ot     optimize for speed
+# -AL     large memory model
+# -Za     ANSI C conformance
+# -nologo suppress MSVC banners
+# -onerror:noexe   no .EXE file if link errors occur
+CFLAGS = -Ot -AL -Za -nologo
+LDFLAGS = -onerror:noexe -nologo
+LIBS = $(LIBDIR)\llibce.lib $(LIBDIR)\graphics.lib
+
+#### End of system configuration section. ####
+
+# This rule allows us to supply the necessary -D options
+# in addition to whatever the user asks for.
+.c.obj:
+	$(CC) -c -I. -I$(INCDIR) $(CPPFLAGS) $(CFLAGS) $<
+
+OBJ =	main.obj screen.obj brac.obj ch.obj charset.obj cmdbuf.obj command.obj \
+	decode.obj edit.obj filename.obj forwback.obj help.obj ifile.obj \
+	input.obj jump.obj line.obj linenum.obj lsystem.obj \
+	mark.obj optfunc.obj option.obj opttbl.obj os.obj output.obj \
+	position.obj prompt.obj search.obj signal.obj tags.obj \
+	ttyin.obj version.obj multi.obj unify.obj
+
+all: less lesskey
+
+# This is really horrible, but the command line is too long for 
+# MS-DOS if we try to link $(OBJ).
+less: $(OBJ)
+	-if exist lesskey.obj del lesskey.obj
+	$(CC) $(LDFLAGS) -o $@ *.obj $(LIBS)
+
+lesskey: lesskey.obj version.obj
+	$(CC) $(LDFLAGS) -o $@ lesskey.obj version.obj $(LIBS)
+
+defines.h: defines.ds
+	-del defines.h
+	-copy defines.ds defines.h
+
+$(OBJ): less.h multi.h defines.h
+
+clean:
+	-del *.obj 
+	-del less.exe
+	-del lesskey.exe
+
Index: less/Makefile.o2e
diff -u less/Makefile.o2e:1.1.1.1 less/Makefile.o2e:1.4
--- less/Makefile.o2e:1.1.1.1	Sat Nov 30 14:41:23 1996
+++ less/Makefile.o2e	Thu Mar 12 17:29:04 1998
@@ -23,7 +23,7 @@
 	help.${O} ifile.${O} input.${O} jump.${O} line.${O} linenum.${O} \
 	lsystem.${O} mark.${O} optfunc.${O} option.${O} opttbl.${O} os.${O} \
 	output.${O} position.${O} prompt.${O} search.${O} signal.${O} \
-	tags.${O} ttyin.${O} version.${O}  regexp.${O}
+	tags.${O} ttyin.${O} version.${O}  regexp.${O} multi.${O} unify.${O}
 
 all:    less.exe lesskey.exe
 
@@ -33,7 +33,7 @@
 lesskey.exe: lesskey.${O} version.${O}
 	${CC} lesskey.${O} version.${O} -o $@ ${LDFLAGS}
 
-${OBJ}: defines.h less.h
+${OBJ}: defines.h less.h multi.h
 
 defines.h: defines.o2
 	copy defines.o2 defines.h
Index: less/Makefile.o9c
diff -u less/Makefile.o9c:1.1.1.2 less/Makefile.o9c:1.5
--- less/Makefile.o9c:1.1.1.2	Sat Nov 30 14:41:24 1996
+++ less/Makefile.o9c	Thu Mar 12 17:29:04 1998
@@ -27,7 +27,7 @@
 	help.${O} ifile.${O} input.${O} jump.${O} line.${O} linenum.${O} \
 	lsystem.${O} mark.${O} optfunc.${O} option.${O} opttbl.${O} os.${O} \
 	output.${O} position.${O} prompt.${O} search.${O} signal.${O} \
-	tags.${O} ttyin.${O} version.${O}  regexp.${O}
+	tags.${O} ttyin.${O} version.${O}  regexp.${O} multi.${O} unify.${O}
 
 all: less lessecho lesskey
 
@@ -40,7 +40,7 @@
 lessecho: lessecho.${O} version.${O}
 	${CC} lessecho.${O} version.${O} -f=$@ ${LDFLAGS}
 
-${OBJ}: defines.h less.h
+${OBJ}: defines.h less.h multi.h
 
 defines.h: defines.o9
 	copy defines.o9 defines.h -rf
Index: less/Makefile.o9u
diff -u less/Makefile.o9u:1.1.1.1 less/Makefile.o9u:1.4
--- less/Makefile.o9u:1.1.1.1	Fri Sep 13 10:36:40 1996
+++ less/Makefile.o9u	Thu Mar 12 17:29:04 1998
@@ -26,7 +26,7 @@
 	help.${O} ifile.${O} input.${O} jump.${O} line.${O} linenum.${O} \
 	lsystem.${O} mark.${O} optfunc.${O} option.${O} opttbl.${O} os.${O} \
 	output.${O} position.${O} prompt.${O} search.${O} signal.${O} \
-	tags.${O} ttyin.${O} version.${O}  regexp.${O}
+	tags.${O} ttyin.${O} version.${O}  regexp.${O} multi.${O} unify.${O}
 
 all: less lesskey
 
@@ -36,7 +36,7 @@
 lesskey: lesskey.${O} version.${O}
 	${CC} lesskey.${O} version.${O} -f=$@ ${LDFLAGS}
 
-${OBJ}: defines.h less.h
+${OBJ}: defines.h less.h multi.h
 
 defines.h: defines.o9
 	copy defines.o9 defines.h -rf
Index: less/Makefile.wnb
diff -u less/Makefile.wnb:1.1.1.1 less/Makefile.wnb:1.4
--- less/Makefile.wnb:1.1.1.1	Sat Nov 30 14:41:25 1996
+++ less/Makefile.wnb	Thu Mar 12 17:29:04 1998
@@ -23,7 +23,7 @@
 	input.obj jump.obj line.obj linenum.obj lsystem.obj \
 	mark.obj optfunc.obj option.obj opttbl.obj os.obj output.obj \
 	position.obj prompt.obj search.obj signal.obj tags.obj \
-	ttyin.obj version.obj regexp.obj
+	ttyin.obj version.obj regexp.obj multi.obj unify.obj
 
 all: less lesskey
 
@@ -40,7 +40,7 @@
 	-del defines.h
 	-copy defines.wn defines.h
 
-${OBJ}: less.h defines.h funcs.h cmd.h
+${OBJ}: less.h multi.h defines.h funcs.h cmd.h
 
 clean:
 	-del *.obj 
Index: less/Makefile.wnm
diff -u less/Makefile.wnm:1.1.1.2 less/Makefile.wnm:1.5
--- less/Makefile.wnm:1.1.1.2	Tue Sep 21 20:02:13 1999
+++ less/Makefile.wnm	Tue Sep 21 22:44:01 1999
@@ -28,7 +28,7 @@
 	input.obj jump.obj line.obj linenum.obj lsystem.obj \
 	mark.obj optfunc.obj option.obj opttbl.obj os.obj output.obj \
 	position.obj prompt.obj search.obj signal.obj tags.obj \
-	ttyin.obj version.obj regexp.obj
+	ttyin.obj version.obj regexp.obj multi.obj unify.obj
 
 all: less.exe lesskey.exe
 
@@ -45,7 +45,7 @@
 	-del defines.h
 	-copy defines.wn defines.h
 
-$(OBJ): less.h defines.h funcs.h cmd.h
+$(OBJ): less.h multi.h defines.h funcs.h cmd.h
 
 clean:
 	-del *.obj 
Index: less/README.iso
diff -u /dev/null less/README.iso:1.19
--- /dev/null	Wed Dec  6 22:29:41 2000
+++ less/README.iso	Tue Nov 21 09:01:27 2000
@@ -0,0 +1,234 @@
+=========================================================================
+    This is the distribution of enhanced less.
+    It support ISO 2022 code extension techniques and Japanese codes.
+    Please report any problems of it to the author at jam@pobox.com.
+    See http://www.pobox.com/~jam/less/ for the latest info.
+=========================================================================
+
+
+**Features**
+
+ - Support ISO 2022 code extension techniques in 7bits and 8bits.
+ - Understand all following codes.
+   - ISO 2022 level 3.
+   - a special sequence, ESC 2/4[$] 2/12[,] FE, which is used in MULE.
+   - LESS-JIS, UJIS and SJIS.
+     - LESS-JIS may contain JIS C 6226-1978, JIS X 0208-1983,
+       JIS X 0208:1990/1997, JIS X 0212:1990, JIS X 0213:2000,
+       JIS X 0201:1976/1997 left/right planes, and ASCII.
+     - UJIS may contain one of JIS C 6226-1978, JIS X 0208-1983,
+       JIS X 0208:1990/1997, or JIS X 0213:2000 plane 1, one of
+       JIS X 0201:1976/1997 left plane or ASCII, JIS X 0201:1976/1997
+       right plane, and both JIS X 0212:1990 and JIS X 0213:2000
+       plane 2.
+     - SJIS may contain one of JIS C 6226-1978, JIS X 0208-1983,
+       JIS X 0208:1990/1997, or JIS X 0213:2000 plane 1, one of
+       JIS X 0201:1976/1997 left plane or ASCII, JIS X 0201:1976/1997
+       right plane, and JIS X 0213:2000 plane 2.
+ - Output following codes.
+   - iso8 (CTEXT, which is defined in X11)
+   - iso7 with only GZDM4, GZD4, G1DM4, G1DM6, G1D4, G1D6, SI and SO
+     escape sequences.
+   - LESS-JIS, UJIS and SJIS.
+     - LESS-JIS may contain JIS X 0208-1983 with an assumption
+       that its face is the same as JIS X 0213:2000 plane 1,
+       JIS X 0201:1976/1997 left/right planes and ASCII.
+       It does not contain JIS X 0212:1990 or JIS X 0213:2000 plane 2,
+       so those are marked as wrong character on the fly.
+       If you need the same JIS sequence as the input, please use iso7
+       or iso8.
+     - UJIS may contain one of JIS C 6226-1978, JIS X 0208-1983,
+       JIS X 0208:1990/1997, or JIS X 0213:2000 plane 1, one of
+       JIS X 0201:1976/1997 left plane or ASCII, JIS X 0201:1976/1997
+       right plane, and both JIS X 0212:1990 and JIS X 0213:2000
+       plane 2.
+     - SJIS may contain one of JIS C 6226-1978, JIS X 0208-1983,
+       JIS X 0208:1990/1997, or JIS X 0213:2000 plane 1, one of
+       JIS X 0201:1976/1997 left plane or ASCII, JIS X 0201:1976/1997
+       right plane, and JIS X 0213:2000 plane 2.
+ - Automatic decompression of compressed files.
+
+**Problems**
+
+ - To search, the less compare characters after conversion into
+   internal codes.  If converted codes contain some gaps, a regular
+   expression library is confused.  e.g. "$B$"(Ba" which contain an escape
+   sequence and codes which is JIS X 0201 Japanese (Katakana) in UJIS
+   make problems.
+ - If you have a regular expression library with ability to detect
+   character set, you don't get this problem.
+ - Or if you search it without using regular expression library by
+   typing '^R', you can solve this problem.
+
+**Enhancements**
+
+ - The JLESSCHARSET environment variable choose codes for input and
+   output.  For example, if you set "japanese-iso7", the less read all
+   Japanese codes and iso7 and write iso7.  If you set "ujis", the
+   less read and write only UJIS.  Currently you can use followings.
+   - Same as LESSCHARSET: ascii, latin1, dos, koi8-r, next
+   - Others: iso7, iso8, ujis-iso7, euc-iso7, sjis-iso7, jis,
+	     ujis-jis, euc-jis, sjis-jis, ujis, euc, jis-ujis,
+	     jis-euc, sjis, jis-sjis, japanese, japanese-iso7,
+	     japanese-jis, japanese-ujis, japanese-euc, japanese-sjis
+ - Following values of JLESSCHARSET are treated for input and output
+   separately.  For example, if you set "ujis-sjis", the less read
+   only UJIS and write only SJIS.
+   - Values: ujis-sjis, euc-sjis, sjis-ujis, sjis-euc
+ - The JLESSPLANESET environment variable choose plane of iso8 and
+   iso7.  Please read a manual about details.
+ - The JLESSKEYCHARSET environment variable choose codes for input
+   from keyboard.  All values for the JLESSCHARSET environment
+   variable are used for this.
+ - Sometime the less may mistake automatic handling of Japanese codes.
+   The user change the status for it by '@' key.  The function name of
+   it is "rotate-right".
+ - If you have a regular expression library with character set
+   detection, invoke configure script with "--with-cs-regex" option to
+   use it.  Then compile the less.
+
+**History about Japanized and ISO 2022-ized less**
+
+ - About Japanization of less
+   - Kato-san posted a difference which give less an ability for
+     special escape sequence.
+   - Kameyama-san posted a patch for UJIS code.
+   - Shinoda-san posted a less.exe for SJIS code.
+   - Tachi-san posted two patches for JIS and SJIS code.
+   - Saito-san posted kanji conversion filter for less.
+   - Ohta-san posted other less which convert roma-ji into kana.
+   - Yamakita-san posted other patch for convert them into kanji.
+   - Yoshida-san posted two patches of less-73 for UJIS and SJIS code.
+   - Yoshida-san posted two patches of less-97 for UJIS and SJIS code.
+   - Kato-san posted a patch of less-97(UJIS) for JIS code.
+   - Ishii-san posted a patch of less-97(UJIS or SJIS) for JIS code.
+   - Tanaka-san posted a modified less-123 for SJIS code.
+   - Kawakami-san posted a patch of it for JIS code.
+   - I changed less-177 for all Japanese codes.
+   - Kusakabe-san changed less-178 by using patches for less-177.
+   - Senda-san add printing function of Japanese code for less-177.
+   - Sakai-san changed less-200 by using patches for less-178.
+   - I changed less-205 for all Japanese codes and ISO 2022 codes.
+   - Ushine-san changed less-321 by using patches for less-290.
+   - I changed less-330 by using patches for less-290.  It is named
+     iso202.
+   - I removed some bugs and made jless-330-iso203.
+   - I re-wrote jless and made jless-330-iso208.
+   - I released patches to correct bugs.
+
+ - About jless
+   - I put 2 unofficial patches of KANJI searching enhancements for
+     ISO 2022-ized less-237 on ftp.
+   - I put an unofficial patch to use gawk-2.15.6-mb1.04's KANJI
+     regular expression library for jless-330-iso210 on ftp.  It will
+     works with iso212 and following.
+   - I put a less.hlp file which is translated into Japanese.  It will
+     works with iso212 and following.
+
+**FAQ**
+
+ Q: When I try to view a Japanese text, the less shows inverse
+    characters only.  How do I view them?
+ A: You have to set "japanese" to the JLESSCHARSET environment
+    variable.  Otherwise you have to set "ja_JP" to the LANG
+    environment variable if your computer support it.
+
+ Q: When I try to view a Japanese text, the less shows strange
+    characters only like '$' and others.  How do I view them?
+ A: Do your terminal or terminal emulator have ability to show
+    Japanese?  If so, I guess you have to adjust output of the less by
+    setting "japanese-ujis" or "japanese-sjis" as the JLESSCHARSET
+    environment variable.
+
+ Q: When I try to view compressed text, the less doesn't work.  How do
+    I view them?
+ A: The less uses the name of a text file to check whether it is
+    compressed or not, and uses a "zcat" program to uncompress it.  So
+    the compressed file has to be finished with ".z", ".gz" or ".Z"
+    and a "zcat" program has to have ability to uncompress it.
+
+ Q: How to set the default value of the JLESSCHARSET environment
+    variable.
+ A: You can use a DEFCHARSET declaration in "defines.h".  If your
+    computer has a LANG property, you have to set HAVE_LOCALE to 0 in
+    "defines.h".  Note: before editing it, you should execute a
+    "configure" program.
+
+ Q: Sometime my terminal shows non ASCII characters only.
+ A: Some terminal emulators have bugs in handling the ISO 2022.  You
+    should tell the less to display only JIS by setting "japanese-jis"
+    to the JLESSCHARSET environment variable.
+
+ Q: Sometime the less shows wrong Japanese characters when I try to
+    view SJIS coded files.
+ A: A less's automatic Japanese code handling routine is not perfect.
+    Please type '^L' to re-display it.  If it doesn't work fine,
+    please type '@' to change it to the manually handling routine.
+
+    On the other hand, if you use the less with a -Z option, the less
+    give priority to SJIS over UJIS in automatic handling routine.
+    And you can change the default value of priority and invert the
+    means of a -Z option by compiling with SJIS_PRE declaration.
+
+    Or if you know the file is SJIS before executing the less, you
+    should set "sjis" to the JLESSCHARSET environment variable to
+    diable the automatic handling routine.
+
+ Q: How do I use SJIS as typing string?
+ A: You should set "sjis-jis" to the JLESSKEYCHARSET environment
+    variable.  Otherwise you should set "sjis-jis" to a DEFKEYCHARSET
+    declaration in "defines.h".
+
+ Q: Can I use regular expression with Japanese?
+ A: There are 2 ways.  You can use multi bytes regular expression
+    library.  Or you can use regular expression library with ability
+    to detect character sets.
+
+    Please read "http://www.poboxes.com/~jam/less/".
+
+ Q: When I looking up with Kanji, the less shows strange behavior.
+ A: The less enables MSB of bytes of all non ASCII characters to
+    decrease mis-matching between an ASCII character and an non ASCII
+    characters if they have same value.  But your regular expression
+    library might not support characters enabled MSB.  Please invoke
+    configure script with "--disable-msb" option to disable it.  Then
+    compile the less.
+
+ Q: How do I input search pattern by JIS?
+ A: Normally the less uses "\e$" sequence.  You should write following
+    in your "~/.lesskey" file and execute a "lesskey" program to
+    cancel it.
+
+#line-edit
+\e$	insert ^V\e$
+
+ Q: How do I use emacs-like key binding?
+ A: You should write following in your "~/.lesskey" file and execute a
+    "lesskey" program.
+
+#line-edit
+^A	home
+^E	end
+^P	up
+^N	down
+^F	right
+^B	left
+\ef	word-right
+^D	delete
+\ed	word-delete
+
+ Q: The os.c was not compiled on NEWS-OS 4.0C.
+ A: Add following before "#include <setjmp.h>".
+
+#define LANGUAGE_C   1
+
+**Conclusion**
+
+ - Please mail to "jam@pobox.com" if you have a problem or a suggestion.
+ - See http://www.pobox.com/~jam/less/ for the latest info.
+
+
+Local Variables:
+mode: indented-text
+fill-column: 70
+End:
